#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin >> n;
    char niz[n];
    bool imaa = false;
    short strik = 1;
    int ab[26];
    for(short i = 0; i < 26; i++){
        ab[i] = 0;
    }
    for(int i = 0; i < n; i++){
        cin >> niz[i];
        ab[niz[i] - 'A']++;
        if(imaa && niz[i] == strik + 'A'){
            strik++;
        }
        else if(!imaa && niz[i] == 'A'){
            imaa = true;
        }
    }
    if(strik == 26){
        long long ukupno = 1;
        for(short i = 0; i < 26; i++){
            for(int j = 2; j <= ab[i]; j++){
                ukupno *= j;
                cout << ukupno << endl;
            }
        }
        cout << ukupno % 1000000007;
    }
    else{
        cout << 0;
    }
}